package jp.ac.uaizu.rdbs.aop;

import java.lang.reflect.Field;

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.springframework.stereotype.Component;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;

@Aspect
@Component
public class SpringAspect {

	public void showJoinPoint(String from, JoinPoint jp) {
		System.out.println(from + ":" + jp.getTarget().getClass().getSimpleName() + "." + jp.getSignature().getName());
		Object[] args = jp.getArgs();
		for (Object o : args) {
			System.out.println(from + ":" + o);
		}
	}

	@Before("execution(* jp.ac.uaizu.rdbs.*.*Controller.*(..))")
	public void beforeAdvice(JoinPoint jp) {

		System.out.println("beforeAdvice：StaticPart(" + jp.getStaticPart() + ")");
//		Logger logger = LoggerFactory.getLogger("test");
//		logger.info("beforeAdvice：StaticPart(" + jp.getStaticPart() + ")");
	    Object[] objArray = jp.getArgs();
	    
	    for (Object obj : objArray) {
	        System.out.println("引数の値です。 : " + objectToString(obj));
//			logger.info("引数の値です。 : " + objectToString(obj));
	    }
	}

	private String objectToString(Object obj) {
	    StringBuilder sb = new StringBuilder();
	    try {
	    	sb.append("Class: " + obj.getClass().getCanonicalName() + "\n");
	    } catch (NullPointerException e) {
		    return sb.toString();
	    }
	    
	    sb.append("Settings:\n");
	    for (Field field : obj.getClass().getDeclaredFields()) {
	        try {
	            field.setAccessible(true);
	            sb.append(field.getName() + " = " + field.get(obj) + "\n");
	        } catch (IllegalAccessException e) {
	            sb.append(field.getName() + " = " + "access denied\n");
	        }
	    }
	    return sb.toString();
	}
}
