package jp.ac.uaizu.rdbs.common;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

@ControllerAdvice
public class GlobalExceptionHandler {

	private static final Logger logger = LogManager.getLogger(GlobalExceptionHandler.class);
	
	@ExceptionHandler
	@ResponseStatus(HttpStatus.INTERNAL_SERVER_ERROR)
	public ModelAndView handleException(Exception e) {
    	logger.fatal("GlobalExceptionHandler", e);

    	ModelAndView mav = new ModelAndView();

    	// JSPに表示するメッセージをセットします。
    	mav.addObject("message", RDBSConstants.Message.MSG_ERR_001);
    	
        // 遷移先のJSPを指定します。(error.jspに遷移します。)
        mav.setViewName("error");
        
		return mav;
	}
}
