package jp.ac.uaizu.rdbs.common;

import org.springframework.validation.BindingResult;
import org.springframework.validation.ObjectError;
import org.springframework.web.bind.annotation.ControllerAdvice;

@ControllerAdvice
public class GlobalFormValidation {

	/**
	 * Find error result of input form and return error message as return value
	 * @param result Input form confirmation result
	 * @return Error message(Returns an empty string if no error has occurred)
	 */
	public String getErrorMsg(BindingResult result) {
		String errorMsg = "";
		for (ObjectError error : result.getAllErrors()) {
			errorMsg = error.getDefaultMessage();
			if (errorMsg != null) {
	    		break;
			}
		}
		
		return errorMsg;
	}
}
