package jp.ac.uaizu.rdbs.common;

public class RDBSConstants {
	/**
	 * Suppress instance creation with private constructor
	 */
	private RDBSConstants() {}
	
	/**
	 * Program fixed value
	 */
	public static class FixedValue {
		/*Package name*/
		public static final String PACKAGE_NAME = "RDBS";
		
		/*Salt definition*/
		public static final String HATH_SALT = "Hash_value_you_defined";
		
		/*Video data context path (data is a symbolic link)*/
		public static final String CONTEXT_PATH_MOVIE_DATA = "./resources/data/video";
		public static final String CONTEXT_PATH_DOWNLOAD_DATA = "./resources/data/download/tmp";
		public static final String CONTEXT_PATH_TMP_DATA = "./resources/data/tmp";

		/*Database table name*/
		public static final String USER_TBL = " users ";
		public static final String GRID_MAP_2D_TBL = " maps ";

	}
	
	/**
	 *  application.properties
	 */
	public static class ApplicationProperties {
		public static final String PROP_NAME_DOWNLOAD_PATH = "app.downloadPath";
		public static final String PROP_NAME_RDR_ROOT_PATH = "app.rdr_root_path";
	}
	
	/** 
	 * Message
	 */
	public static class Message {
		public static final String MSG_INF_001 = "Video file upload succeeded.";
		public static final String MSG_ERR_001 = "The user ID or password you entered is incorrect.";
		public static final String MSG_WAR_002 = "User ID is empty";
		public static final String MSG_WAR_003 = "Password is empty";
		public static final String MSG_WAR_004 = "Please enter single-byte alphanumeric characters";
		public static final String MSG_WAR_005 = "Please enter between 1 and 16 characters";
		public static final String MSG_WAR_006 = "Please enter between 8 and 16 characters";
		public static final String MSG_WAR_007 = "Contains invalid symbols";
		public static final String MSG_WAR_008 = "File path is empty";
		public static final String MSG_WAR_009 = "Shooting Date is empty";
		public static final String MSG_WAR_010 = "The Shooting Date format is incorrect";
		public static final String MSG_WAR_011 = "The maximum number of characters that can be entered is ";
	}
	
	/**
	 * Login session constant
	 */
	public static class LoginSession {
		public static final String LOGIN_STATE_KEY = "LoginStateKey";
		public static final String LOGIN_STATE_ENABLE = "LOGIN";
		public static final String LOGIN_STATE_DISABLE = "LOGOUT";
		
		public static final boolean ATTRIBUTE_SET_LOGIN = true;
		public static final boolean ATTRIBUTE_SET_LOGOUT = false;
	}
	
	/**
	 * SQL statement
	 */
	public static class RequestSQL {
		public static final String LOGIN_AUTHENTICATION_QUERY = "select * from " + FixedValue.USER_TBL + 
																"where user_name = ? and password = ?";
		
		public static final String MAP_SEARCH_CONDITION_QUERY = "(select * from " + FixedValue.GRID_MAP_2D_TBL + 
																"where robot_id ilike ? and location ilike ? and " +
																" ? <= extract(epoch from datetime) and " + 
																"extract(epoch from datetime) <= ?)"; 
	}
}
