package jp.ac.uaizu.rdbs.form;

import java.io.Serializable;

import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import jp.ac.uaizu.rdbs.common.RDBSConstants.Message;

public class DownloadForm  implements Serializable {
	private static final long serialVersionUID = 1L;
	
	/**
	 * Selected Robot id
	 */
//	@Pattern(regexp = "^[0-9a-zA-Z]+$", message = Message.MSG_WAR_004)
	@Pattern(regexp = "^[a-zA-Z0-9]*$", message = Message.MSG_WAR_004)
	@Pattern(regexp = "^\\w{0,16}$", message = Message.MSG_WAR_005)
	private String RobotId;

	/**
	 * location to be searched
	 */
	@Size(min=0, max=128, message = Message.MSG_WAR_011 + "128")
	@Pattern(regexp = "^([^\"\'])*$", message = Message.MSG_WAR_007)
	private String Location;

	/**
	 * date
	 */
	@Pattern(regexp = "^(19[0-9]{2}|20[0-9]{2})-([1-9]|0[1-9]|1[012])-([1-9]|0[1-9]|[12][0-9]|3[01])$", message = Message.MSG_WAR_010)
	private String DateFrom;

	/**
	 * date
	 */
	@Pattern(regexp = "^(19[0-9]{2}|20[0-9]{2})-([1-9]|0[1-9]|1[012])-([1-9]|0[1-9]|[12][0-9]|3[01])$", message = Message.MSG_WAR_010)
	private String DateTo;
	
	public void setRobotId(String RobotId) {
		this.RobotId = RobotId;
	}
	
	public void setLocation(String Location) {
		this.Location = Location;
	}
	
	public void setDateFrom(String DateFrom) {
		this.DateFrom = DateFrom;
	}
	
	public void setDateTo(String DateTo) {
		this.DateTo = DateTo;
	}
	
	public String getRobotId() {
		return this.RobotId;
	}
	
	public String getLocation() {
		return this.Location;
	}
	
	public String getDateFrom() {
		return this.DateFrom;
	}
	
	public String getDateTo() {
		return this.DateTo;
	}
}

