package jp.ac.uaizu.rdbs.form;

import java.io.Serializable;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Pattern;

import jp.ac.uaizu.rdbs.common.RDBSConstants.Message;

/**
 * Login input form class
 */
public class LoginForm implements Serializable {
	private static final long serialVersionUID = 1L;
	
	/**
	 * Login user id
	 */
	@NotEmpty(message = Message.MSG_WAR_002)
	@Pattern(regexp = "^[0-9a-zA-Z]+$", message = Message.MSG_WAR_004)
	@Pattern(regexp = "^\\w{1,16}$", message = Message.MSG_WAR_005)
	private String LoginId;
	
	/**
	 * Get login user id
	 * @return login id
	 */
    public String getLoginId() {
		return LoginId;
	}

    /**
     * Update login user id
     * @param LoginId
     */
	public void setLoginId(String LoginId) {
		this.LoginId = LoginId;
	}
	
	/**
	 * Password id
	 */
	@NotEmpty(message = Message.MSG_WAR_003)
	@Pattern(regexp = "^[0-9a-zA-Z]+$", message = Message.MSG_WAR_004)
	@Pattern(regexp = "^\\w{8,16}$", message = Message.MSG_WAR_006)
	private String PasswordId;
	
	/**
	 * Get password id
	 * @return Password id
	 */
    public String getPasswordId() {
		return PasswordId;
	}

    /**
     * Update password id
     * @param PasswordId
     */
	public void setPasswordId(String PasswordId) {
		this.PasswordId = PasswordId;
	}
}
