package jp.ac.uaizu.rdbs.repository;

import java.util.Map;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.dao.DataAccessException;
import org.springframework.dao.EmptyResultDataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;

import jp.ac.uaizu.rdbs.common.RDBSConstants.RequestSQL;

/**
 * Repository class of login function 
 */
@Repository
public class LoginRepository {
	
	private Logger logger = LogManager.getLogger(LoginRepository.class);
	
	@Autowired
	@Qualifier("jdbcTemplateSecond")
	private JdbcTemplate jdbcTemplate;

	/**
	 * Create a query and search the login user from DB.
	 * @param UserName
	 * @param Password
	 * @return Search result
	 */
	public boolean retrieveUserInfo(String UserName, String Password) {
		boolean result = false;
		logger.info(Password);
		try {
			Map<String, Object> wk = jdbcTemplate.queryForMap(RequestSQL.LOGIN_AUTHENTICATION_QUERY, UserName, Password);
			result = true;
		}
		catch(EmptyResultDataAccessException e){
			logger.warn("Login user not found");
			return result;
		}
		catch(DataAccessException e) {
			logger.error("An unexpected error occurred while querying DB for login");
			return result;
		}
		
		return result;
	}
	
}
