package jp.ac.uaizu.rdbs.service;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

//import org.apache.logging.log4j.LogManager;
//import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import jp.ac.uaizu.rdbs.dao.MapFileInfoDao;
import jp.ac.uaizu.rdbs.repository.DownloadRepository;

@Service
public class DownloaderService {
//	private Logger logger = LogManager.getLogger(DownloaderService.class);
	
	@Autowired
	private DownloadRepository downloadRepository;


	/**
	 * Perform video optimization. Further, a meta information file of a moving image is generated,
	 * and date information is added when the moving image has no date information.
	 * @param videoPathBefor Upload video path.
	 * @param storeDirPath Destination directory path.
	 * @param shootingTime Date information set by the user.
	 */
	public List<MapFileInfoDao> findMapInfo(String robotId, String location, String dateFrom, String dateTo){
		return downloadRepository.fetchMapInfo(robotId, location, dateFrom, dateTo);
	}
	
    /**
     * Processing to write files to Zip package
     * @param outStream Zip output stream
     * @param fileName File name to be compressed
     * @param entryFile File information to be compressed
     * @param inStream Input stream
     * @throws IOException Processing thrown by exception
     */
	 public void createZip(ZipOutputStream outStream, String fileName, File entryFile, InputStream inStream) throws IOException {
    	byte[] buf = new byte[1024];
		ZipEntry entry = new ZipEntry(fileName);
		outStream.putNextEntry(entry);
		inStream = new BufferedInputStream(new FileInputStream(entryFile));
		int len = 0;
		
        while ((len = inStream.read(buf)) != -1) {
        	outStream.write(buf, 0, len);
        }
        inStream.close();
        outStream.closeEntry();
    	
    }
}
