package jp.ac.uaizu.rdbs.service;

import java.math.BigInteger;
import java.security.MessageDigest;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import jp.ac.uaizu.rdbs.common.RDBSConstants.FixedValue;
import jp.ac.uaizu.rdbs.repository.LoginRepository;

/**
 * Service class of Login function
 */
@Service
public class LoginService {

	private Logger logger = LogManager.getLogger(LoginService.class);
	
	@Autowired
	private LoginRepository loginRepository;
	
	/**
	 * Perform password hashing.
	 * Authenticates whether the hashed password and user name exist in the DB,
	 * and returns the result.
	 * @param UserName
	 * @param Password
	 * @return Authentication result
	 */
	public boolean loginAuth(String UserName, String Password) {
		boolean result = false;
		
		try {
			/*Hash password*/
			MessageDigest digest = MessageDigest.getInstance("SHA-256");
			digest.reset();
			String combinedStr = FixedValue.HATH_SALT + Password + UserName;
			
			digest.update(combinedStr.getBytes("utf8"));
			String HashPass = String.format("%064x", new BigInteger(1, digest.digest()));
			
			if(loginRepository.retrieveUserInfo(UserName, HashPass)) {
				result = true;
			}
		}
		catch (Exception e) {
			logger.error(e.getMessage());
		}
	
		return  result;
	}
}
